library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity ALOG is
    port (
                SCK:   in std_logic;
		CONV: out std_logic;
		SDO:   in std_logic;

		ADC_R0: out std_logic_vector(13 downto 0);
		ADC_R1: out std_logic_vector(13 downto 0);

		TRG_LEV: in std_logic_vector(13 downto 0);  

		RAM_CLK: out std_logic
	);
end ALOG;

architecture Behavioral of ALOG is

-- signals
--------------------------------------------
	signal BIT_CNT: natural range 0 to 63;
	signal ADC_GO:  std_logic;

	signal ADC0: std_logic_vector(13 downto 0);
	signal ADC1: std_logic_vector(13 downto 0);

	signal RAM_GTE: std_logic;
	signal RAM_STB: std_logic;

	signal CYC_CNT: natural range 0 to 16777215; -- ~1sec @ 12.5 MHz
	signal CYC_END: std_logic;
--------------------------------------------

--------------------------------------------

begin
--------------------------------------------





-- RAM write strobe
--------------------------------------------
	process(SCK, BIT_CNT)
	begin
		if (SCK'event and SCK = '0') then
			case BIT_CNT is
				when 1 =>
					RAM_STB <= '1';
				when 5 =>
					RAM_STB <= '0';
				when 9 =>
					RAM_STB <= '1';
				when 13 =>
					RAM_STB <= '0';
				when 17 =>
					RAM_STB <= '1';
				when 21 =>
					RAM_STB <= '0';
				when 25 =>
					RAM_STB <= '1';
				when 29 =>
					RAM_STB <= '0';
				when others =>
					null;
			end case;
		end if;
	end process;
--------------------------
	RAM_CLK <= RAM_GTE and RAM_STB;
--------------------------------------------







end Behavioral;
